*
* DDS MICRO-C 68HC11 Runtime Library - Prefix file
*
* Copyright 1991-1996 Dave Dunfield
* All rights reserved.
*
* 68HC711D3 registers are at $0000, Internal RAM is at $0040
?REGS	EQU	$1000		68HC711D3 internal registers
?parm	EQU	$0000		Parameter to runtime library
?temp	EQU	?parm+2		Temporary register
	ORG	$f800		Place code in memory here
?begin	LDS	#$00FF		Initial stack goes here
* For raw system, you may have to shut down COP etc.
*	LDAA	#%00000100	Disable COP and internal ROM
*	STAA	?REGS+$3F	Write CONFIG register
	CLR	?heap		Zero out the heap
	JSR	main		Call user module
* Return to MON11 by jumping to its startup address
* Wait for pending serial I/O to complete first.
exit	CLRA			Get a big...
	CLRB			Timeout counter
?exit1	SUBD	#1		Reduce
	BNE	?exit1		Wait for expiry
	JMP	$E000		Re-enter monitor
*02106
*#file 11ghzsrc.c
*16:
*17:             
*19:
*#file c:\local\personal\micros\uc11\6811reg.h
*6:
*7:
*8:
*9:extern char ADCTL, ADR1, ADR2, ADR3, ADR4, BPROT, PORTA, PORTB, PORTC, PORTD, PIOC, DDRB, DDRC, DDRD, CFORC, OC1M,
*10:	OC1D, TCTL1, TCTL2, TMSK1, TFLG1, TMSK2, TFLG2, PACTL, PACNT, SPCR, SPSR,
*11:	SPDR, BAUD, SCCR1, SCCR2, SCSR, SCDR, OPTION, COPRST, PPROG, HPRIO, INIT,
*12:	TEST1, CONFIG;
*13:
*14:extern unsigned TCNT, TIC1, TIC2, TIC3, TOC1, TOC2, TOC3, TOC4, TI4O5;
*#file c:\local\personal\micros\uc11\6811io.h
*5:
*6:
*9:
*10:extern register printf(), sprintf(), concat();
*11:
*#file c:\local\personal\micros\uc11\6811int.h
*35:
*55:
*#file c:\local\personal\micros\uc11\intvect.h
*11:
*12:
*13:
*35:
*36:
*#file 11ghzsrc.c
*24:
*25:
*#file c:\local\personal\src\embed_c\sync.c
*8:
*#file c:\local\personal\src\embed_c\sync.h
*8:
*9:
*10:
*17:
*22:
*23:
*24:
*25:
*29:
*30:
*33:
*34:
*35:
*36:
*#file c:\local\personal\src\embed_c\sync.c
*10:
*15:
*16:spi_init(unsigned char cfg)
*17:{
*18:  if(cfg & 0x10)           
spi_init EQU *
 TSY
 LDAB 3,Y
 ANDB #16
 BNE *+5
 JMP ?AB1
*19:    DDRD|=0x38;
 LDAB DDRD
 ORAB #56
 STAB DDRD
*20:  else 
 JMP ?AB2
?AB1 EQU *
*21:    DDRD |=0x08;
 LDAB DDRD
 ORAB #8
 STAB DDRD
?AB2 EQU *
*22:
*23:  SPCR=cfg;                    
 TSY
 LDAB 3,Y
 STAB SPCR
*24:
*25:}
 RTS
*26:
*27:
*28:
*31:
*32:unsigned char spi_xfer(unsigned char data)
*33:{
*34:  SPDR=data;        
spi_xfer EQU *
 TSY
 LDAB 3,Y
 STAB SPDR
*35:
*36:  while(!(SPSR&0x80));     
?AB3 EQU *
 LDAB SPSR
 ANDB #128
 BNE *+5
 JMP ?AB3
?AB4 EQU *
*37:
*38:  return(SPDR);               
 LDAB SPDR
 JSR ?sign
*39:
*40:}
?AB5 EQU *
 RTS
*41:
*42:
*43:
*44:
*45:
*46:
*47:
*48:
*49:
*#file 11ghzsrc.c
*27:
*#file ints.c
*12:
*13:
*14:
*15:
*16:asm{
*16:$SE:0
*16:_65522
_65522
*16:	org 65522
	org 65522
*16:	FDB _65522
	FDB _65522
*16:	org _65522
	org _65522
*16:	LDX ?parm
	LDX ?parm
*16:	PSHX
	PSHX
*16:	LDX ?temp
	LDX ?temp
*16:	PSHX
	PSHX
*16:	BSR _65522+15
	BSR _65522+15
*16:	PULX
	PULX
*16:	STX ?temp
	STX ?temp
*16:	PULX
	PULX
*16:	STX ?parm
	STX ?parm
*16:	RTI
	RTI
*16:} irq_isr()
*17:{
*18:  return;
irq_isr EQU *
*19:}
?AB6 EQU *
 RTS
*20:
*21:
*22:
*23:
*24:asm{
*24:$SE:0
*24:_65524
_65524
*24:	org 65524
	org 65524
*24:	FDB _65524
	FDB _65524
*24:	org _65524
	org _65524
*24:	LDX ?parm
	LDX ?parm
*24:	PSHX
	PSHX
*24:	LDX ?temp
	LDX ?temp
*24:	PSHX
	PSHX
*24:	BSR _65524+15
	BSR _65524+15
*24:	PULX
	PULX
*24:	STX ?temp
	STX ?temp
*24:	PULX
	PULX
*24:	STX ?parm
	STX ?parm
*24:	RTI
	RTI
*24:} xirq_isr()
*25:{
*26:  return;
xirq_isr EQU *
*27:}
?AB7 EQU *
 RTS
*#file 11ghzsrc.c
*29:
*31:
*33:
*39:
*40:main()
*41:{
*42:
*43:  char input_buffer[10];
*44:  unsigned fmhz;
*45:  unsigned r;
*46:  unsigned n;
*47:  unsigned p;
*48:  unsigned char a;
*49:  unsigned char ref_div_reg[2];
*50:  unsigned char main_div_reg[3];
*51:  unsigned char flag;
*52:
*53:  flag =0;    
main TSX
 XGDX
 SUBD #25
 XGDX
 TXS
 CLRB
 TSY
 STAB 24,Y
*54:  
*55:
*56:  BAUD=0x30;  
 LDAB #48
 STAB BAUD
*57:  SCCR1=0; 
 CLRB
 STAB SCCR1
*58:  SCCR2=0x0c; 
 LDAB #12
 STAB SCCR2
*59:
*60:
*61:
*62: spi_init(0x10|0x40|0x02);  
 LDD #82
 PSHB
 PSHA
 JSR spi_init
 PULX
*63:
*64: PORTB&=~0x80; 
 LDAB PORTB
 ANDB #-129
 STAB PORTB
*74:  
*75:
*77:  
*78:  
*79:  p=64;  
 LDD #64
 TSY
 STD 16,Y
*80:
*81:  for(;;) 
?AB8 EQU *
*82:    {
*83:      
*84:      if(!flag)
 TSY
 LDAB 24,Y
 BEQ *+5
 JMP ?AB10
*85:	{
*86:	  fmhz=12000; 
 LDD #12000
 STD 10,Y
*87:	}
*88:      else
 JMP ?AB11
?AB10 EQU *
*89:	{
*90:	  printf("enter freq in MHz %d>",fmhz);
 LDD #?AB0+0
 PSHB
 PSHA
 TSY
 LDD 12,Y
 PSHB
 PSHA
 LDD #2
 JSR printf
 PULX
 PULX
*91:	  getstr(input_buffer,10);
 TSX

 XGDX
 PSHB
 PSHA
 LDD #10
 PSHB
 PSHA
 JSR getstr
 PULX
 PULX
*92:	  fmhz=atoi(input_buffer);
 TSX

 XGDX
 PSHB
 PSHA
 JSR atoi
 PULX
 TSY
 STD 10,Y
*93:	  if((fmhz<10000) || (fmhz >15000))
 LDD 10,Y
 STD ?parm
 LDD #10000
 JSR ?ult
 BNE ?AB13
 LDD 10,Y
 STD ?parm
 LDD #15000
 JSR ?ugt
?AB13 EQU *
 BNE *+5
 JMP ?AB12
*94:	    {
*95:	      printf("\n 10000< Freq < 15000\n, setting to default 12000");
 LDD #?AB0+22
 PSHB
 PSHA
 LDD #1
 JSR printf
 PULX
*96:	      fmhz=12000;
 LDD #12000
 TSY
 STD 10,Y
*97:	    }
*98:	}
?AB12 EQU *
?AB11 EQU *
*99:
*100:      flag=1; 
 LDAB #1
 TSY
 STAB 24,Y
*101:
*102:      
*103:      printf("\nfreq in MHz = %d\n",fmhz);
 LDD #?AB0+71
 PSHB
 PSHA
 LDD 10,Y
 PSHB
 PSHA
 LDD #2
 JSR printf
 PULX
 PULX
*104:
*105:      
*106:
*107:      
*108:      
*109:      
*111:      
*112:      
*113:      r=120;  
 LDD #120
 TSY
 STD 12,Y
*114:      
*115:      
*116:      n=fmhz/p;  
 LDD 10,Y
 STD ?parm
 LDD 16,Y
 JSR ?udiv
 STD 14,Y
*117:      a=fmhz%p;  
 LDD 10,Y
 STD ?parm
 LDD 16,Y
 JSR ?mod
 STAB 18,Y
*118:
*119:            
*120:      printf("\nn=%d a=%d\n",n,a);
 LDD #?AB0+90
 PSHB
 PSHA
 LDD 14,Y
 PSHB
 PSHA
 LDAB 18,Y
 CLRA
 PSHB
 PSHA
 LDD #3
 JSR printf
 PULX
 PULX
 PULX
*121:
*122:      
*123:      
*124:      r<<=1;  
 TSY
 LDD 12,Y
 STD ?parm
 LDD #1
 JSR ?shl
 STD 12,Y
*125:      r |= 0x0001;; 
 LDD 12,Y
 ORAA #0
 ORAB #1
 STD 12,Y
*126:      r |= 0x8000;; 
 LDD 12,Y
 ORAA #128
 ORAB #0
 STD 12,Y
*127:      
*128:      
*129:      
*130:      
*131:      
*132:      ref_div_reg[0]=(unsigned char) r&0xff;
 TSX
 XGDX
 ADDD #0+19
 XGDX
 LDD 12,Y
 ANDB #255
 CLRA
 STAB ,X
*133:      
*134:      ref_div_reg[1]=(unsigned char) ((r>>8) &0xff);
 TSX
 XGDX
 ADDD #1+19
 XGDX
 LDD 12,Y
 STD ?parm
 LDD #8
 JSR ?shr
 ANDA #0
 ANDB #255
 STAB ,X
*135:      
*136:      
*137:      spi_xfer(ref_div_reg[1]);
 TSX
 XGDX
 ADDD #1+19
 XGDX
 LDAB ,X
 CLRA
 PSHB
 PSHA
 JSR spi_xfer
 PULX
*138:      spi_xfer(ref_div_reg[0]);
 TSX
 XGDX
 ADDD #0+19
 XGDX
 LDAB ,X
 CLRA
 PSHB
 PSHA
 JSR spi_xfer
 PULX
*139:      
*141:      
*142:      
*143:      PORTB|=0x80; 
 LDAB PORTB
 ORAB #128
 STAB PORTB
*144:      PORTB&=~0x80; 
 LDAB PORTB
 ANDB #-129
 STAB PORTB
*145:      
*146:      
*148:      
*149:      
*150:      
*151:      main_div_reg[0]=a<<1; 
 TSX
 XGDX
 ADDD #0+21
 XGDX
 TSY
 LDAB 18,Y
 CLRA
 STD ?parm
 LDD #(1)&$FF
 JSR ?shl
 STAB ,X
*152:      main_div_reg[0] &=~0x0001;; 
 TSX
 XGDX
 ADDD #0+21
 XGDX
 LDAB ,X
 ANDB #-2
 STAB ,X
*153:      
*154:      main_div_reg[1]=(unsigned char)n & 0x00ff;
 TSX
 XGDX
 ADDD #1+21
 XGDX
 LDD 14,Y
 ANDB #255
 CLRA
 STAB ,X
*155:      
*156:      main_div_reg[2]=(unsigned char)((n>>8) & 0xff);
 TSX
 XGDX
 ADDD #2+21
 XGDX
 LDD 14,Y
 STD ?parm
 LDD #8
 JSR ?shr
 ANDA #0
 ANDB #255
 STAB ,X
*157:      
*158:      spi_xfer(main_div_reg[2]);
 TSX
 XGDX
 ADDD #2+21
 XGDX
 LDAB ,X
 CLRA
 PSHB
 PSHA
 JSR spi_xfer
 PULX
*159:      spi_xfer(main_div_reg[1]);
 TSX
 XGDX
 ADDD #1+21
 XGDX
 LDAB ,X
 CLRA
 PSHB
 PSHA
 JSR spi_xfer
 PULX
*160:      spi_xfer(main_div_reg[0]);
 TSX
 XGDX
 ADDD #0+21
 XGDX
 LDAB ,X
 CLRA
 PSHB
 PSHA
 JSR spi_xfer
 PULX
*161:      
*162:      
*163:      PORTB|=0x80; 
 LDAB PORTB
 ORAB #128
 STAB PORTB
*164:      PORTB&=~0x80; 
 LDAB PORTB
 ANDB #-129
 STAB PORTB
*165:      
*166:      
*167:      
*168:      
*169:      
*170:      
*171:    }
 JMP ?AB8
?AB9 EQU *
*172:  
*173:
*174:     
*175:
*176:  
*177:
*178:  
*179:}
 TSX
 XGDX
 ADDD #25
 XGDX
 TXS
 RTS
*180:
*181:
*182:
*183:
*184:
*185:
*186:
*187:
*188:
?AB0 FCB 101,110,116,101,114,32,102,114,101,113,32,105,110,32,77,72
 FCB 122,32,37,100,62,0,10,32,49,48,48,48,48,60,32,70
 FCB 114,101,113,32,60,32,49,53,48,48,48,10,44,32,115,101
 FCB 116,116,105,110,103,32,116,111,32,100,101,102,97,117,108,116
 FCB 32,49,50,48,48,48,0,10,102,114,101,113,32,105,110,32
 FCB 77,72,122,32,61,32,37,100,10,0,10,110,61,37,100,32
 FCB 97,61,37,100,10,0
* 68HC11 Internal register definitions
* 'C' declarations are in: 6811REG.H
PORTA	EQU	?REGS+$00
PIOC	EQU	?REGS+$02
PORTC	EQU	?REGS+$03
PORTB	EQU	?REGS+$04
DDRB	EQU	?REGS+$06
DDRC	EQU	?REGS+$07
PORTD	EQU	?REGS+$08
DDRD	EQU	?REGS+$09
CFORC	EQU	?REGS+$0B
OC1M	EQU	?REGS+$0C
OC1D	EQU	?REGS+$0D
TCNT	EQU	?REGS+$0E
TIC1	EQU	?REGS+$10
TIC2	EQU	?REGS+$12
TIC3	EQU	?REGS+$14
TOC1	EQU	?REGS+$16
TOC2	EQU	?REGS+$18
TOC3	EQU	?REGS+$1A
TOC4	EQU	?REGS+$1C
TI4O5	EQU	?REGS+$1E
TCTL1	EQU	?REGS+$20
TCTL2	EQU	?REGS+$21
TMSK1	EQU	?REGS+$22
TFLG1	EQU	?REGS+$23
TMSK2	EQU	?REGS+$24
TFLG2	EQU	?REGS+$25
PACTL	EQU	?REGS+$26
PACNT	EQU	?REGS+$27
SPCR	EQU	?REGS+$28
SPSR	EQU	?REGS+$29
SPDR	EQU	?REGS+$2A
BAUD	EQU	?REGS+$2B
SCCR1	EQU	?REGS+$2C
SCCR2	EQU	?REGS+$2D
SCSR	EQU	?REGS+$2E
SCDR	EQU	?REGS+$2F
ADCTL   EQU	?REGS+$30
ADR1    EQU	?REGS+$31
ADR2    EQU	?REGS+$32
ADR3    EQU	?REGS+$33
ADR4    EQU	?REGS+$34	
OPTION	EQU	?REGS+$39
COPRST	EQU	?REGS+$3A
PPROG	EQU	?REGS+$3B
HPRIO	EQU	?REGS+$3C
INIT	EQU	?REGS+$3D
TEST1	EQU	?REGS+$3E
CONFIG	EQU	?REGS+$3F
*02106
* Terminal printf: register printf(format, args ...)
printf	TSX			Address stack
	ABX			Offset for first parm
	ABX			Twice for word entries
	TSY			Y = stack
	XGDY			D = stack
	SUBD	#100		Output buffer
	XGDY			Y = output buffer
	TYS			S = output buffer
	PSHY			Save output pointer
	JSR	_format_	Call formatter
	JSR	putstr		Output the string
	TSX			X = stack
	XGDX			D = stack
	ADDD	#102		Clean args + buffer
	XGDX			X = stack
	TXS			S = stack
	RTS
*02106
*
* DDS MICRO-C Serial I/O functions for the 68HC11
*
* Input functions
*
* Test for character from console - Translate returns
chkch	LDAA	?REGS+$2E	Get SCI status
	ANDA	#%00100000	RX ready?
	BNE	?AE1		Yes, handle it
	CLRB			Zero LOW
	RTS
* Read character from console - Translate Returns
getch	LDAA	?REGS+$2E	Get SCI status
	BITA	#%00100000	RX ready?
	BEQ	getch		No, wait for it
?AE1	LDAB	?REGS+$2F	Read the character
	CLRA			Zero HIGH
	CMPB	#$0D		Return?
	BNE	?AE3		Its OK
	LDAB	#$0A		Convert to newline
	RTS
* Test for character from console - Raw format
chkchr	LDAA	?REGS+$2E	Get SCI status
	ANDA	#%00100000	RX ready?
	BNE	?AE2		Yes, handle it
	LDD	#-1		Get -1
	RTS
* Read character from console - Raw format
getchr	LDAA	?REGS+$2E	Get SCI status
	BITA	#%00100000	RX ready?
	BEQ	getchr		No, wait for it
?AE2	LDAB	?REGS+$2F	Read the character
	CLRA			Zero high
?AE3	RTS
* Read a string (with editing) from the console: getstr(buffer, length)
getstr	TSX			Address stack
	LDY	4,X		Get buffer ptr
	LDX	#0		Starting length is zero
?AE4	BSR	getch		Get a character
	CMPB	#$7F		Delete?
	BEQ	?AE5		Yes, handle it
	CMPB	#$08		Backspace?
	BEQ	?AE5		Yes, handle it
	CMPB	#$0A		Enter?
	BEQ	?AE6		Yes, handle it
	PSHY			Save buffer ptr
	TSY			Address stack
	CPX	4,Y		Are we within length
	PULY			Restore buffer ptr
	BHS	?AE4		No, ignore
	STAB	,Y		Write to buffer
	INX			Advance length
	INY			Advance buffer ptr
	BSR	?putchr		Echo character to console
	BRA	?AE4		And proceed
?AE5	CPX	#0		Any data in buffer?
	BEQ	?AE4		No, ignore
	LDAB	#$08		Backspace
	BSR	?putchr		Echo
	LDAB	#' '		Overwrite with space
	BSR	?putchr		Echo
	LDAB	#$08		Backspace
	BSR	?putchr		Echo
	DEX			Reduce length
	DEY			Reduce buffer ptr
	BRA	?AE4		And proceed
?AE6	CLR	,Y		Zero end of buffer
	BSR	?putch		New line on console
	XGDX			Return buffer length
	RTS
*
* Output functions
*
* Write a string to the serial port: putstr(char *s)
putstr	TSX			Point to parms
	LDX	2,X		Get pointer
* Write string(X) to serial port
?putstr	LDAB	,X		Get char
	BEQ	?AE3		End of line, exit
	INX			Advance pointer
	BSR	?putch		Write char to serial port
	BRA	?putstr		And proceed
* Write character to serial port port with newline translation
putch	TSX			Point to stack
	LDD	2,X		Get character value
* Write character(B) to serial port with newline translation
?putch	CMPB	#$0A		Newline?
	BNE	?putchr		No, standard char
	BSR	?putchr		Write LF
	LDAB	#$0D		Get CR
	BRA	?putchr		Write character
* Write character to serial port in RAW form: putchr(char c)
putchr	TSX			Point to stack
	LDD	2,X		Read character
* Write character(B) to serial port in RAW form
?putchr	LDAA	?REGS+$2E	Get SCI status
	BITA	#%10000000	Ok to transmit?
	BEQ	?putchr		No, do not write
	STAB	?REGS+$2F	Write character to Data register
	RTS
*02106
*
* Get a decimal number from a string: atoi(string)
*
atoi	TSX			Address parms
	LDX	2,X		Get string
	CLRA			Zero HIGH
	CLRB			Zero LOW
	STD	?parm		Reset ?mul parameter
* Skip any leading whitespace
?AF1	LDAA	,X		Get char
	INX			Advance
	CMPA	#' '		Space?
	BEQ	?AF1		Skip spaces
	CMPA	#9		Tab?
	BEQ	?AF1		Skip tabs
* Handle leading '-'
	CMPA	#'-'		Minus?
	BNE	?AF2		No, its OK
	BSR	?AF3		Get value
	COMA			Invert LOW
	COMB			Invert HIGH
	ADDD	#1		Convert to two's comp
	RTS
* Collect the digits & generate value
?AF2	DEX			Backip
?AF3	LDAA	,X		Get char
	INX			Advance to next
	SUBA	#'0'		Convert
	CMPA	#9		In range?
	BHI	?AF4		No, its the end
	PSHA			Save digit
	LDD	#10		Value *= 10
	JSR	?mul		Do multiply
	TSY			Address stack
	ADDB	,Y		Add in LOW
	ADCA	#0		Adjust high
	STD	?parm		Save new value
	INS			Clean up
	BRA	?AF3		And proceed
?AF4	LDD	?parm		Get final value
	RTS
*02106
*
* Shared format routine used by the various versions of "printf"
* Input: Y=output pointer, X=argument pointer
*
_format_ PSHX			Save argument pointer
	STY	?parm		Save output pointer
	LDY	,X		Get format string
* Process next character from format string
?AG1	LDAA	,Y		Get next char
	INY			Advance to next
	CMPA	#'%'		Format string?
	BEQ	?AG2		Yes, handle it
	LDX	?parm		Get output string
	STAA	,X		Write to output
	INX
	STX	?parm		Resave output pointer
	TSTA			All done?
	BNE	?AG1		No, keep going
	PULX			Restore arg pointer
	RTS
* Test for '-', left justify
?AG2	LDAA	,Y		Get next character
	LDAB	#' '		Assume space
	CMPA	#'-'		Left justify?
	BNE	?AG3		No, its OK
	ORAB	#%10000000	Set LJ bit
	INY			Advance format string
	LDAA	,Y		Get next char
?AG3	CMPA	#'0'		Zero fill?
	BNE	?AG4		No, its OK
	ORAB	#'0'		Convert to ZF
?AG4	STAB	?temp		Save for later
* Evaluate field width
	CLRB			Zero width
?AG5	LDAA	,Y		Get char
	SUBA	#'0'		Convert to BIN
	CMPA	#10		In range?
	BHS	?AG6		No, end of number
	INY			Advance pointer
	PSHA			Save for later
	LDAA	#10		X10 for decimal numbers
	MUL			Get new result
	TSX			Address stack
	ADDB	,X		Include result
	PULA			Restore char
	BRA	?AG5		And proceed
* Interpret the format specifier
?AG6	STAB	?temp+1		Save width
	PULX			Get ptr to args
	DEX			Backup
	DEX			Backup
	PSHX			Resave
	LDX	,X		Get argument value
	LDAA	,Y		Get char
	INY			Advance
	PSHY			Save format string
	LDY	?parm		Get output pointer
* 'b' Binary number
	LDAB	#2		Base 2
	CMPA	#'b'		Binary output?
	BEQ	?AG8		Yes, do it
* 'o' Octal number
	LDAB	#8		Base 8
	CMPA	#'o'		Octal output?
	BEQ	?AG8		Yes, do it
* 'x' Hexidecimal number
	LDAB	#16		Base 16
	CMPA	#'x'		Hex output?
	BEQ	?AG8		Yes, do it
* 'u' Unsigned number
	CMPA	#'u'		Unsigned output?
	BEQ	?AG7		Yes, do it
* 'd' Decimal number
	CMPA	#'d'		Decimal output?
	BNE	?AG20		No, try next
	PSHX			Save X
	PULA			Get in HIGH acc
	PULB			Get in LOW acc
	TSTA			Check for negative
	BPL	?AG7		No problems
	COMA			Complement high
	COMB			Complement low
	ADDD	#1		Get two's complement
	XGDX			And swap back
	LDAA	#'-'		Get negative output
	STAA	,Y		Write in output
	INY			Advance
	STY	?parm		Resave output ptr
	LDAB	?temp+1		Get length
	BEQ	?AG7		Free format, its OK
	DEC	?temp+1		Adjust length
?AG7	LDAB	#10		Base 10 output
* Output number in X using base in B
?AG8	CLRA			Zero count
	PSHA			Save marker
* Process value & stack digits
?AG9	PSHB			Save BASE
	PSHA			Save COUNT
	PULY			Y = count/base
	CLRA			D = base only
	XGDX			D=number, X=base
	IDIV			X=num/base, D=num%base
	ADDB	#'0'		Convert to ASCII
	CMPB	#'9'		In range?
	BLS	?AG10		Its OK
	ADDB	#7		Convert hex digits
?AG10	PSHB			Save new value
	XGDY			D = count/base
	INCA			Advance count
	CPX	#0		More digits?
	BNE	?AG9		Do them all
* Unpack digits into output buffer
	LDY	?parm		Restore output pointer
	JSR	?AG40		Left fill if necessary
?AG11	PULB			Get char from stack
	TSTB			End of string?
	BEQ	?AG12		No, its OK
	STAB	,Y		Write it out
	INY			Advance
	BRA	?AG11		And proceed
?AG12	TST	?temp		Left justify?
	BPL	?AG13		No, don't pad
	JSR	?AG50		Pad on right
?AG13	STY	?parm		Resave output pointer
	PULY			Restore format string
	JMP	?AG1		And proceed
* 's' string
?AG20	CMPA	#'s'		String output?
	BNE	?AG30		No, its not
	PSHX			Save pointer
	LDAA	#-1		Start count (always loop once)
?AG21	INCA			Advance count
	LDAB	,X		Get char
	INX			Advance ptr
	TSTB			End of string?
	BNE	?AG21		Get length
	PULX			Restore pointer
	JSR	?AG40		Left fill if necessary
?AG22	LDAB	,X		Get char
	BEQ	?AG12		End of string
	STAB	,Y		Write in output
	INX			Advance source
	INY			Advance dest
	BRA	?AG22		And proceed
* 'c' Character
?AG30	TAB			Copy charcter
	CMPA	#'c'		Character output
	BNE	?AG31		No, keep char
	XGDX			B = char
?AG31	LDAA	#1		Width = 1
	JSR	?AG40		Left fill if necessary
	STAB	,Y		Write in output
	INY			Advance output
	BRA	?AG12		And proceed
*
* Pad the field assuming width in A
*
?AG40	TST	?temp		Left justify?
	BMI	?AG54		Yes, Don't pad
?AG50	PSHX			Save X
	PSHB			Save B
	PSHA			Save A (count)
	LDAB	?temp+1		Fixed field?
	BEQ	?AG53		No, exit
	LDAA	?temp		Get fill char
	ANDA	#%00111111	Save char
	TSX			Address stack
?AG52	CMPB	,X		Over count?
	BLS	?AG53		Yes, exit
	STAA	,Y		Write in output
	INY			Advance output
	DECB			Reduce count
	BRA	?AG52		And proceed
?AG53	PULA			Restore A
	PULB			Restore B
	PULX			Restore X
?AG54	RTS
*02106
*
* DDS MICRO-C 68HC11 Runtime library - Middle file
*
* 16 bit Multiply: D = ?parm * D
?mul	PSHX			Save index register
	PSHB			Save low of parameter
	PSHA			Save high of parameter
	PSHX			Holding location for result
	TSX			Set up addressability
	LDAA	3,X		Get low of parm 1
	LDAB	?parm+1		And low of parm 2
	MUL			Multiply to get result
	STD	,X		Save partial result
	LDAA	2,X		Get high of parm 1
	LDAB	?parm+1		And low of parm 2
	MUL			Multiply to get result
	ADDB	,X		Add to high of previous result
	STAB	,X		And resave
	LDAA	3,X		Get low of parm 1
	LDAB	?parm		And high of parm 2
	MUL			Multiply to get result
	ADDB	,X		Add to result
	STAB	,X		And resave
	PULA			Get high result
	PULB			Get low result
	PULX			Clean original parameters
	PULX			Restore index register
	RTS
* 16 bit unsigned division: D = ?parm / D
?udiv	PSHX			Save index register
	XGDX			'X' = denominator
	LDD	?parm		Get numerator
	IDIV			Perform divide
	XGDX			'D' = quotient
	PULX			Restore index register
	RTS
* 16 bit Modulus: D = ?parm % D
?mod	PSHX			Save index register
	XGDX			'X' = denominator
	LDD	?parm		Get numerator
	IDIV			Perform divide
	PULX			Restore index register
	RTS
* Shift left: D = ?parm << D
?shl	PSHX			Save index register
	XGDX			'X' = shift count
	LDD	?parm		'D' = value
	CPX	#0		Special case (0 bit shift)
	BEQ	?shl2		Yes, early exit
?shl1	LSLD			Shift one bit
	DEX			Reduce count
	BNE	?shl1		Not finished, continue
?shl2	PULX			Restore index
	RTS
* Shift right: D = ?parm >> D
?shr	PSHX			Save index register
	XGDX			'X' = shift count
	LDD	?parm		'D' = value
	CPX	#0		Special case (0 bit shift)
	BEQ	?shr2		Yes, early exit
?shr1	LSRD			Shift one bit
	DEX			Reduce count
	BNE	?shr1		Not finished, continue
?shr2	PULX			Restore index
	RTS
* Sign extend B into A (Resulting in 16 bit result)
?sign	CLRA			Assume positive
	TSTB			Check sign of B
	BPL	nargs		Assumption correct
	DECA			Convert to negative
	RTS
* = amd !=
?eq	CPD	?parm		D = ?parm == D
	BEQ	?ret1
* FALSE result, D=0, ZF=1
?ret0	CLRA
	CLRB
nargs	RTS
?ne	CPD	?parm		D = ?parm != D
	BEQ	?ret0
* TRUE result, D=1, ZF=0
?ret1	LDD	#1
	RTS
* Unsigned >, >=, <, <=
?ugt	CPD	?parm		D = ?parm > D
	BLO	?ret1
	BRA	?ret0
?uge	CPD	?parm		D = ?parm >= D
	BLS	?ret1
	BRA	?ret0
?ult	CPD	?parm		D = ?parm < D
	BHI	?ret1
	BRA	?ret0
?ule	CPD	?parm		D = ?parm <= D
	BHS	?ret1
	BRA	?ret0
*#map1 Segment 1 - Internal RAM based variables
	ORG	?temp+2		Position for internal variables
*#map2 Set address of un-initialized variables
* Set up the origin of external RAM based variables.
* Eliminate this statement if you are NOT using external RAM
* and want all variables allocated in internal RAM.
*
*	ORG	$4000		External RAM begins here
*02106
*
* DDS MICRO-C 6811 Runtime library - Suffix file
*
?heap	EQU	*		Heap memory goes here
* For stand-alone ROM system, uncomment the following
	ORG	$FFFE		Position to reset vector
	FDB	?begin		Set start address
*02106
